# pylint: disable=C0301
"""Test response after connection to diplomer"""


def test_issue_endpoint_to_correct_connection(supply_arguments_to_test_good_issue_endpoint_connection):
    """check /issue correct connection response"""
    response = supply_arguments_to_test_good_issue_endpoint_connection
    assert response.status_code == 200
    assert response.content.decode("utf-8") == '[{"msid":1,"iid":1,"teachers":"Ильин","theme":"белые гуси против черных","title":"Ильин: белые гуси против черных",' \
                                               '"description":{"Тема работы":"Программное средство формирования расписания из тематических планов учебных дисциплин.",' \
                                               '"Аннотация":"Разработка программного средства формирования расписания из тематических планов учебных дисциплин и пожеланий ' \
                                               'преподавателей.","Цель дипломной работы":"Разработка программного средства формирования расписания из тематических планов ' \
                                               'учебных дисциплин и пожеланий преподавателей.","Основные вопросы и задачи, подлежащие разработке при выполнении дипломной ' \
                                               'работы":["1. Аналитический обзор существующих алгоритмов и готовых решений для формирования расписания преподавателей.",' \
                                               '"1. Разработка архитектуры разрабатываемого программного средства формирования расписания.",' \
                                               '"1. Изучение формата файла тематического плана учебной дисциплины.",' \
                                               '"1. Реализация модуля для разбора файла тематического плана учебной дисциплины.",' \
                                               '"1. Анализ существующих особенностей расписания преподавателей *(например, день для филиала Квант должен быть выделен монопольно)*",' \
                                               '"1. Выработка формата для возможных пожеланий преподавателей ' \
                                               '*(ставить преподавателя только в указанные дни, не ставить преподавателя в выбранные дни, ' \
                                               'учёт конференций, пожелания по первым/последним парам, субботам, максимальному количеству ' \
                                               'занятий в день и разрывам пар первая-четвертая)*.","1. Реализация модуля для разбора пожеланий преподавателей.",' \
                                               '"1. Реализация программного средства формирования расписания, позволяющего для заданного множества ' \
                                               'тематических планов и пожеланий преподавателей формировать .xlsx-файл расписания."]}},' \
                                               '{"msid":2,"iid":2,"teachers":"Петров","theme":"модель земли под коралловым рифом","title":' \
                                               '"Петров: модель земли под коралловым рифом","description":{"Тема курсовой работы семестра":' \
                                               '"замените_Т_Е_М_У","Аннотация":"замените_Т_Е_К_С_Т_аннотации","Цель курсовой работы осеннего семестра":' \
                                               '"замените_Ц_Е_Л_Ь_осеннего_семестра","Цель курсовой работы весеннего семестра":"замените_Ц_Е_Л_Ь_весеннего_' \
                                               'семестра","Основные вопросы и задачи, подлежащие разработке при выполнении курсовой работы осеннего семестра":' \
                                               '["1. Исследовать","1. Предоставить"],"Основные вопросы и задачи, подлежащие разработке при выполнении курсовой' \
                                               ' работы весеннего семестра":["1. Разработать","1. Предоставить"],"Рекомендации преподавателя":"ЗАМЕНЯТЬ_НЕОБЯЗАТЕЛЬНО"}},' \
                                               '{"msid":3,"iid":10,"teachers":"семенов","theme":"экономист","title":"семенов: экономист","description":' \
                                               '{"Тема курсовой работы семестра":"замените_Т_Е_М_У","Аннотация":"замените_Т_Е_К_С_Т_аннотации",' \
                                               '"Цель курсовой работы осеннего семестра":"замените_Ц_Е_Л_Ь_осеннего_семестра","Цель курсовой работы ' \
                                               'весеннего семестра":"замените_Ц_Е_Л_Ь_весеннего_семестра","Основные вопросы и задачи, подлежащие разработке' \
                                               ' при выполнении курсовой работы осеннего семестра":["1. Исследовать","1. Предоставить"],"Основные вопросы и' \
                                               ' задачи, подлежащие разработке при выполнении курсовой работы весеннего семестра":["1. Разработать","1. Предоставить"],' \
                                               '"Рекомендации преподавателя":"ЗАМЕНЯТЬ_НЕОБЯЗАТЕЛЬНО"}}]'


def test_issue_endpoint_to_incorrect_connection(supply_arguments_to_test_bad_issue_endpoint_connection):
    """check /issue to incorrect connection response"""
    response = supply_arguments_to_test_bad_issue_endpoint_connection
    assert response.content == b'"Error! Connection failed. Check url parameters"'


def test_issue_endpoint_to_incorrect_connection_with_teachers(supply_arguments_to_test_good_issue_endpoint_connection_with_teachers):
    """check /issue to incorrect connection response with teachers"""
    response = supply_arguments_to_test_good_issue_endpoint_connection_with_teachers
    assert response.content.decode("utf-8") == '[{"msid":1,"iid":2,"teachers":"Петров","theme":"модель земли под коралловым рифом",' \
                                               '"title":"Петров: модель земли под коралловым рифом","description":{"Тема курсовой работы семестра":"замените_Т_Е_М_У",' \
                                               '"Аннотация":"замените_Т_Е_К_С_Т_аннотации","Цель курсовой работы осеннего семестра":"замените_Ц_Е_Л_Ь_осеннего_семестра",' \
                                               '"Цель курсовой работы весеннего семестра":"замените_Ц_Е_Л_Ь_весеннего_семестра","Основные вопросы и задачи, ' \
                                               'подлежащие разработке при выполнении курсовой работы осеннего семестра":["1. Исследовать",' \
                                               '"1. Предоставить"],"Основные вопросы и задачи, подлежащие разработке при выполнении курсовой работы весеннего семестра":' \
                                               '["1. Разработать","1. Предоставить"],"Рекомендации преподавателя":"ЗАМЕНЯТЬ_НЕОБЯЗАТЕЛЬНО"}}]'


def test_check_correct_endpoint_to_correct_connection(supply_arguments_to_test_good_check_correct_endpoint_connection):
    """check /check_correct correct connection response"""
    response = supply_arguments_to_test_good_check_correct_endpoint_connection
    assert response.status_code == 200
    assert response.content.decode("utf-8") == '[{"id":3,"error":"Probably you haven`t got colon in: иванов модель кактуса ' \
                                               'You should fill this field like this Петров: модель земли под коралловым ' \
                                               'рифом","content":"**Тема курсовой работы семестра:** ' \
                                               'замените_Т_Е_М_У\\n\\n---\\n*Аннотация:* замените_Т_Е_К_С_Т_аннотации\\n\\n---\\n**Цель курсовой работы осеннего ' \
                                               'семестра:** замените_Ц_Е_Л_Ь_осеннего_семестра\\n\\n---\\n**Цель курсовой работы весеннего семестра:** ' \
                                               'замените_Ц_Е_Л_Ь_весеннего_семестра\\n\\n---\\n**Основные вопросы и задачи, ' \
                                               'подлежащие разработке при выполнении курсовой работы осеннего ' \
                                               'семестра:**\\n1. Изучить\\n1. Исследовать\\n\\n---\\n**Основные вопросы и ' \
                                               'задачи, подлежащие разработке при выполнении курсовой работы весеннего ' \
                                               'семестра:**\\n1. Разработать\\n1. Предоставить\\n\\n---\\n**Рекомендации ' \
                                               'преподавателя:** ЗАМЕНЯТЬ_НЕОБЯЗАТЕЛЬНО\\n\\n---"},{"id":3,"error":"Probably you have a lot of colon in: иванов модель ' \
                                               'кактуса You should fill this field like this Петров: модель земли под коралловым рифом","content":"**Тема курсовой работы семестра:** ' \
                                               'замените_Т_Е_М_У\\n\\n---\\n*Аннотация:* замените_Т_Е_К_С_Т_аннотации\\n\\n---\\n**Цель курсовой работы осеннего семестра:** ' \
                                               'замените_Ц_Е_Л_Ь_осеннего_семестра\\n\\n---\\n**Цель курсовой работы весеннего семестра:** ' \
                                               'замените_Ц_Е_Л_Ь_весеннего_семестра\\n\\n---\\n**Основные вопросы и задачи, подлежащие разработке при выполнении ' \
                                               'курсовой работы осеннего семестра:**\\n1. Изучить\\n1. Исследовать\\n\\n---\\n**Основные вопросы и задачи, подлежащие ' \
                                               'разработке при выполнении курсовой работы весеннего семестра:**\\n1. Разработать\\n1. Предоставить\\n\\n---\\n**Рекомендации ' \
                                               'преподавателя:** ЗАМЕНЯТЬ_НЕОБЯЗАТЕЛЬНО\\n\\n---"},{"id":3,"error":"Probably you haven`t got whitespace in: иванов модель кактуса ' \
                                               'You should fill this field like this Петров: модель земли под коралловым рифом","content":"**Тема курсовой работы семестра:** ' \
                                               'замените_Т_Е_М_У\\n\\n---\\n*Аннотация:* замените_Т_Е_К_С_Т_аннотации\\n\\n---\\n**Цель курсовой работы осеннего семестра:** ' \
                                               'замените_Ц_Е_Л_Ь_осеннего_семестра\\n\\n---\\n**Цель курсовой работы весеннего семестра:** ' \
                                               'замените_Ц_Е_Л_Ь_весеннего_семестра\\n\\n---\\n**Основные вопросы и задачи, подлежащие разработке при выполнении курсовой работы ' \
                                               'осеннего семестра:**\\n1. Изучить\\n1. Исследовать\\n\\n---\\n**Основные вопросы и задачи, подлежащие разработке при выполнении ' \
                                               'курсовой работы весеннего семестра:**\\n1. Разработать\\n1. Предоставить\\n\\n---\\n**Рекомендации преподавателя:** ' \
                                               'ЗАМЕНЯТЬ_НЕОБЯЗАТЕЛЬНО\\n\\n---"},{"id":3,"error":"Probably you haven`t got ** in description field: иванов модель ' \
                                               'кактуса You should fill this field like this **Тема работы:** Программное средство формирования расписания из тематических планов ' \
                                               'учебных дисциплин.","content":"**Тема курсовой работы семестра:** замените_Т_Е_М_У\\n\\n---\\n*Аннотация:* ' \
                                               'замените_Т_Е_К_С_Т_аннотации\\n\\n---\\n**Цель курсовой работы осеннего семестра:** замените_Ц_Е_Л_Ь_осеннего_семестра\\n\\n---\\n' \
                                               '**Цель курсовой работы весеннего семестра:** замените_Ц_Е_Л_Ь_весеннего_семестра\\n\\n---\\n**Основные вопросы и задачи, ' \
                                               'подлежащие разработке при выполнении курсовой работы осеннего семестра:**\\n1. Изучить\\n1. Исследовать\\n\\n---\\n**Основные ' \
                                               'вопросы и задачи, подлежащие разработке при выполнении курсовой работы весеннего семестра:**\\n1. Разработать\\n1. ' \
                                               'Предоставить\\n\\n---\\n**Рекомендации преподавателя:** ЗАМЕНЯТЬ_НЕОБЯЗАТЕЛЬНО\\n\\n---"},{"id":3,"error":"Probably ' \
                                               'you have incorrect symbols in description: *Аннотация or  замените_Т_Е_К_С_Т_аннотации in issue: иванов модель кактуса ' \
                                               'You should fill this field like this **Тема работы:** Программное средство формирования расписания из тематических планов' \
                                               ' учебных дисциплин.","content":"**Тема курсовой работы семестра:** замените_Т_Е_М_У\\n\\n---\\n*Аннотация:* ' \
                                               'замените_Т_Е_К_С_Т_аннотации\\n\\n---\\n**Цель курсовой работы осеннего семестра:** замените_Ц_Е_Л_Ь_осеннего_семестра\\n\\n---\\n' \
                                               '**Цель курсовой работы весеннего семестра:** замените_Ц_Е_Л_Ь_весеннего_семестра\\n\\n---\\n**Основные вопросы и задачи, ' \
                                               'подлежащие разработке при выполнении курсовой работы осеннего семестра:**\\n1. Изучить\\n1. Исследовать\\n\\n---\\n**Основные ' \
                                               'вопросы и задачи, подлежащие разработке при выполнении курсовой работы весеннего семестра:**\\n1. Разработать\\n1. ' \
                                               'Предоставить\\n\\n---\\n**Рекомендации преподавателя:** ЗАМЕНЯТЬ_НЕОБЯЗАТЕЛЬНО\\n\\n---"},{"id":3,"error":"Probably ' \
                                               'you haven`t got whitespace in: \\n*Аннотация:* замените_Т_Е_К_С_Т_аннотации\\n\\n in issue: иванов модель кактуса You ' \
                                               'should fill this field like this **Тема работы:** Программное средство формирования расписания из тематических планов учебных ' \
                                               'дисциплин.","content":"**Тема курсовой работы семестра:** замените_Т_Е_М_У\\n\\n---\\n*Аннотация:* ' \
                                               'замените_Т_Е_К_С_Т_аннотации\\n\\n---\\n**Цель курсовой работы осеннего семестра:** замените_Ц_Е_Л_Ь_осеннего_семестра' \
                                               '\\n\\n---\\n**Цель курсовой работы весеннего семестра:** замените_Ц_Е_Л_Ь_весеннего_семестра\\n\\n---\\n**Основные вопросы и ' \
                                               'задачи, подлежащие разработке при выполнении курсовой работы осеннего семестра:**\\n1. Изучить\\n1. Исследовать\\n\\n---\\n' \
                                               '**Основные вопросы и задачи, подлежащие разработке при выполнении курсовой работы весеннего семестра:**\\n1. Разработать\\n' \
                                               '1. Предоставить\\n\\n---\\n**Рекомендации преподавателя:** ЗАМЕНЯТЬ_НЕОБЯЗАТЕЛЬНО\\n\\n---"},{"id":3,"error":"Probably ' \
                                               'you have got extra whitespace in: \\n*Аннотация:* замените_Т_Е_К_С_Т_аннотации\\n\\n in issue: иванов модель кактуса You ' \
                                               'should fill this field like this **Тема работы:** Программное средство формирования расписания из тематических планов учебных ' \
                                               'дисциплин.","content":"**Тема курсовой работы семестра:** замените_Т_Е_М_У\\n\\n---\\n*Аннотация:* ' \
                                               'замените_Т_Е_К_С_Т_аннотации\\n\\n---\\n**Цель курсовой работы осеннего семестра:** замените_Ц_Е_Л_Ь_осеннего_семестра\\n\\n---\\n' \
                                               '**Цель курсовой работы весеннего семестра:** замените_Ц_Е_Л_Ь_весеннего_семестра\\n\\n---\\n**Основные вопросы и задачи, ' \
                                               'подлежащие разработке при выполнении курсовой работы осеннего семестра:**\\n1. Изучить\\n1. Исследовать\\n\\n---\\n' \
                                               '**Основные вопросы и задачи, подлежащие разработке при выполнении курсовой работы весеннего семестра:**\\n1. Разработать\\n' \
                                               '1. Предоставить\\n\\n---\\n**Рекомендации преподавателя:** ЗАМЕНЯТЬ_НЕОБЯЗАТЕЛЬНО\\n\\n---"}]'

def test_check_correct_endpoint_to_incorrect_connection(supply_arguments_to_test_bad_check_correct_endpoint_connection):
    """check /check_correct to incorrect connection response"""
    response = supply_arguments_to_test_bad_check_correct_endpoint_connection
    assert response.content == b'"Error! Connection failed. Check url parameters"'


def test_connection_without_token(supply_arguments_to_test_connection_without_token):
    """check connection without token in url"""
    response = supply_arguments_to_test_connection_without_token
    assert response.content == b'"\'token\' not found"'


def test_connection_without_label(supply_arguments_to_test_connection_without_labels):
    """check connection without token in url"""
    response = supply_arguments_to_test_connection_without_labels
    assert response.content == b'"\'labels\' not found"'
